const through = require('through2');
const PluginError = require('gulp-util').PluginError;
const PLUGIN_NAME = 'gulp-prefixer';
const jsdom = require("jsdom");
const { JSDOM } = jsdom;

require('console-color-mr');

function gulpJquery(fun) {

	let stream = through.obj(function (file, enc, cb) {
		if (file.isStream()) {
			console.info('Streams are not supported!'.red);
			this.emit('error', new PluginError(PLUGIN_NAME, 'Streams are not supported!'));
			return cb();
		}

		if (file.isBuffer()) {
			//console.info('文件内容是'.red, file.contents);

			const dom = new JSDOM(file.contents);

			const $ = require("jquery")(dom.window);
			let strHtml;
			fun.call(this, $);

			strHtml = dom.window.document.documentElement.outerHTML;

			file.contents = Buffer.concat([new Buffer(strHtml)]);
		}

		this.push(file);

		cb();

		console.info('gulp-jquery success!');
	});

	return stream;
}

module.exports = gulpJquery;